import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Still here.
 * @author (your name) 
 * @version (a version number or a date)
 */

public class Player extends Mario
{
    /**
     * Act - do whatever the Still wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        //=======================debug==========================
        //if (Greenfoot.isKeyDown("g"))
        //{
        //  getWorld().addObject(new SubGoomba(getX(), getY()), getX(), getY());
        //}
        //======================================================
        
        isAlive = true;     //if this is act() is called the player is alive
        int moveSize = 300; //the buffer on the edges of the screen where the background will scroll
        movement();         //calls the player movement code
        
        /*
         * The following block of code is the code that scrolls the background
         * when the player is within "moveSize" of the edge of the screen
         */
        
        if (getX()>= getWorld().getWidth()-moveSize)
        {
            BlockParent.blockX -= moveSpeed;
            if (getOneIntersectingObject(Block.class) != null ||
                    getOneIntersectingObject(GroundBlock.class) != null)
            {
                while (getOneIntersectingObject(Block.class) != null ||
                        getOneIntersectingObject(GroundBlock.class) != null)
                {
                    setLocation(getX()-moveSpeed, getY());
                    //System.out.println("moving left to avoid collision");
                }
            }
            while (getX()>= getWorld().getWidth()-moveSize)
            {
                setLocation(getX()-1, getY());
            }
        }
        if (getX()<= moveSize)
        {
            BlockParent.blockX += moveSpeed;
            if (getOneIntersectingObject(Block.class) != null ||
                    getOneIntersectingObject(GroundBlock.class) != null)
            {
                while (getOneIntersectingObject(Block.class) != null ||
                        getOneIntersectingObject(GroundBlock.class) != null)
                {
                    setLocation(getX()+moveSpeed, getY());
                    //System.out.println("moving left to avoid collision");
                }
            }
            while (getX() <= moveSize)
            {
                setLocation(getX()+1, getY());
            }
        }
        /*
         * End of scrolling code
         */
        
        
        if (goombaDie() == true) // detects if the player was killed by a goomba
        {
            return;
        }
        
        gravity(); //calculates the gravity and applies collisions
        
        if (getY()+30 > getWorld().getHeight()) // kills player if they go below the map
        {
            die();
        }
        
        debug(); //self explanatory
    }    
}
